"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const path_1 = require("path");
const rollupCommonjsPlugin = require("rollup-plugin-commonjs");
const rollupNodeResolvePlugin = require("rollup-plugin-node-resolve");
const logger_1 = require("../logger/logger");
function getRollupInputConfig(sourcePath, target, config) {
    return __awaiter(this, void 0, void 0, function* () {
        return {
            external: Object.keys(config.dependencies),
            input: path_1.posix.join(sourcePath, `${config.fileName}.js`),
            onwarn: (warning) => {
                if (warning.message.indexOf('THIS_IS_UNDEFINED') !== -1) {
                    return;
                }
                if (warning.message.indexOf('UNUSED_EXTERNAL_IMPORT') !== -1) {
                    return;
                }
                const betterWarningMessage = warning.message
                    .replace(/\\/g, '/')
                    .replace(sourcePath.split(path_1.posix.sep).slice(-2).join(path_1.posix.sep), config.entry.folder.split(path_1.posix.sep).pop());
                logger_1.Logger.warn(`${warning.code} – ${betterWarningMessage} (${target} target)`);
            },
            preserveSymlinks: true,
            plugins: [
                rollupNodeResolvePlugin(),
                rollupCommonjsPlugin()
            ]
        };
    });
}
exports.getRollupInputConfig = getRollupInputConfig;
function getRollupOutputConfig(format, config) {
    return {
        format,
        globals: config.dependencies,
        name: config.fileName,
        sourcemap: true
    };
}
exports.getRollupOutputConfig = getRollupOutputConfig;
//# sourceMappingURL=rollup.config.js.map